<?php
/**
 * @file
 * Views interface for simplenews.
 */

/**
 * Implementation of hook_views_data().
 */
function simplenews_statistics_views_data() {
/* ------------ Simplenews statistics main table ----------------------*/
  $data['simplenews_statistics']['table']['group']  = t('Simplenews statistics');

  // joins
  $data['simplenews_statistics']['table']['join'] = array(
    //...to the node table
    'node' => array(
      'left_field' => 'nid',
      'field' => 'nid',
    ),
  );

  $data['simplenews_statistics']['send'] = array(
      'title' => t('Sent mails'),
      'help' => t('The number of sent mails.'),
      'field' => array(
        'handler' => 'views_handler_field_numeric',
        'click sortable' => TRUE,
      ),
      'filter' => array(
        'handler' => 'views_handler_filter_numeric',
        'allow empty' => TRUE,
      ),
      'argument' => array(
        'handler' => 'views_handler_argument_numeric',
      ),
      'sort' => array(
        'handler' => 'views_handler_sort',
      ),
  );

  $data['simplenews_statistics']['total_opens'] = array(
      'title' => t('Total opens'),
      'help' => t('Total number of opens'),
      'field' => array(
        'handler' => 'views_handler_field_numeric',
        'click sortable' => TRUE,
      ),
      'filter' => array(
        'handler' => 'views_handler_filter_numeric',
        'allow empty' => TRUE,
      ),
      'argument' => array(
        'handler' => 'views_handler_argument_numeric',
      ),
      'sort' => array(
        'handler' => 'views_handler_sort',
      ),
  );

  $data['simplenews_statistics']['unique_opens'] = array(
      'title' => t('Unique opens'),
      'help' => t('Total number of user-unique opens'),
      'field' => array(
        'handler' => 'views_handler_field_numeric',
        'click sortable' => TRUE,
      ),
      'filter' => array(
        'handler' => 'views_handler_filter_numeric',
        'allow empty' => TRUE,
      ),
      'argument' => array(
        'handler' => 'views_handler_argument_numeric',
      ),
      'sort' => array(
        'handler' => 'views_handler_sort',
      ),
  );

  $data['simplenews_statistics']['total_clicks'] = array(
      'title' => t('Total clicks'),
      'help' => t('Total number of clicks'),
      'field' => array(
        'handler' => 'views_handler_field_numeric',
        'click sortable' => TRUE,
      ),
      'filter' => array(
        'handler' => 'views_handler_filter_numeric',
        'allow empty' => TRUE,
      ),
      'argument' => array(
        'handler' => 'views_handler_argument_numeric',
      ),
      'sort' => array(
        'handler' => 'views_handler_sort',
      ),
  );

  $data['simplenews_statistics']['user_unique_click_through'] = array(
      'title' => t('User unique click through'),
      'help' => t('Total number of user-unique click through'),
      'field' => array(
        'handler' => 'views_handler_field_numeric',
        'click sortable' => TRUE,
      ),
      'filter' => array(
        'handler' => 'views_handler_filter_numeric',
        'allow empty' => TRUE,
      ),
      'argument' => array(
        'handler' => 'views_handler_argument_numeric',
      ),
      'sort' => array(
        'handler' => 'views_handler_sort',
      ),
  );

/* ------------ Simplenews statistics opens table ----------------------*/
  $data['simplenews_statistics_opens']['table']['group']  = t('Simplenews statistics Opens');

  // joins
  $data['simplenews_statistics_opens']['table']['join'] = array(
    //...to the node table
    'node' => array(
      'left_field' => 'nid',
      'field' => 'nid',
    ),
  );

  $data['simplenews_statistics_opens']['email'] = array(
      'title' => t('E-mail'),
      'help' => t('The email address.'),
      'field' => array(
        'handler' => 'views_handler_field',
        'click sortable' => TRUE,
      ),
      'filter' => array(
        'handler' => 'views_handler_filter_string',
        'allow empty' => TRUE,
      ),
      'argument' => array(
        'handler' => 'views_handler_argument_string',
      ),
      'sort' => array(
        'handler' => 'views_handler_sort',
      ),
  );

  $data['simplenews_statistics_opens']['timestamp'] = array(
      'title' => t('Timestamp'),
      'help' => t('The time the user opened the mail.'),
      'field' => array(
        'handler' => 'views_handler_field_date',
        'click sortable' => TRUE,
      ),
      'filter' => array(
        'handler' => 'views_handler_filter_date',
        'allow empty' => TRUE,
      ),
      'argument' => array(
        'handler' => 'views_handler_argument_date',
      ),
      'sort' => array(
        'handler' => 'views_handler_sort_date',
      ),
    );



/* ------------ Simplenews statistics clicks table ----------------------*/
  $data['simplenews_statistics_clicks']['table']['group']  = t('Simplenews statistics Clicks');

  // joins
  $data['simplenews_statistics_clicks']['table']['join'] = array(
    //...to the node table
    'node' => array(
      'left_field' => 'nid',
      'field' => 'nid',
    ),
  );

  $data['simplenews_statistics_clicks']['email'] = array(
      'title' => t('E-mail'),
      'help' => t('The email address.'),
      'field' => array(
        'handler' => 'views_handler_field',
        'click sortable' => TRUE,
      ),
      'filter' => array(
        'handler' => 'views_handler_filter_string',
        'allow empty' => TRUE,
      ),
      'argument' => array(
        'handler' => 'views_handler_argument_string',
      ),
      'sort' => array(
        'handler' => 'views_handler_sort',
      ),
  );

  $data['simplenews_statistics_clicks']['url'] = array(
      'title' => t('URL'),
      'help' => t('The clicked URL.'),
      'field' => array(
        'handler' => 'views_handler_field_url',
        'click sortable' => TRUE,
      ),
      'filter' => array(
        'handler' => 'views_handler_filter_string',
        'allow empty' => TRUE,
      ),
      'argument' => array(
        'handler' => 'views_handler_argument_string',
      ),
      'sort' => array(
        'handler' => 'views_handler_sort',
      ),
  );

  $data['simplenews_statistics_clicks']['timestamp'] = array(
      'title' => t('Timestamp'),
      'help' => t('The time the user clicked this link.'),
      'field' => array(
        'handler' => 'views_handler_field_date',
        'click sortable' => TRUE,
      ),
      'filter' => array(
        'handler' => 'views_handler_filter_date',
        'allow empty' => TRUE,
      ),
      'argument' => array(
        'handler' => 'views_handler_argument_date',
      ),
      'sort' => array(
        'handler' => 'views_handler_sort_date',
      ),
    );

  return $data;
}
